require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_MACH_APIC_H)) {
    eval 'sub __ASM_MACH_APIC_H () {1;}' unless defined(&__ASM_MACH_APIC_H);
    require 'mach_apicdef.ph';
    require 'asm/smp.ph';
    eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_FLAT);}' unless defined(&APIC_DFR_VALUE);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub target_cpus {
        my($void) = @_;
	    eval q({ } );
    }' unless defined(&target_cpus);
    eval 'sub TARGET_CPUS () {( &target_cpus());}' unless defined(&TARGET_CPUS);
    eval 'sub NO_BALANCE_IRQ () {(0);}' unless defined(&NO_BALANCE_IRQ);
    eval 'sub esr_disable () {(0);}' unless defined(&esr_disable);
    eval 'sub INT_DELIVERY_MODE () { &dest_LowestPrio;}' unless defined(&INT_DELIVERY_MODE);
    eval 'sub INT_DEST_MODE () {1;}' unless defined(&INT_DEST_MODE);
    eval 'sub check_apicid_used {
        my($bitmap,$apicid) = @_;
	    eval q({  &physid_isset($apicid, $bitmap); });
    }' unless defined(&check_apicid_used);
    eval 'sub check_apicid_present {
        my($bit) = @_;
	    eval q({  &physid_isset($bit,  &phys_cpu_present_map); });
    }' unless defined(&check_apicid_present);
    eval 'sub ioapic_phys_id_map {
        my($phys_map) = @_;
	    eval q({ $phys_map; });
    }' unless defined(&ioapic_phys_id_map);
    eval 'sub clustered_apic_check {
        my($void) = @_;
	    eval q({  &printk(\\"Enabling APIC mode:  %s.  Using %d I/O APICs\\\\n\\", \\"Flat\\",  &nr_ioapics); });
    }' unless defined(&clustered_apic_check);
    eval 'sub multi_timer_check {
        my($apic,$irq) = @_;
	    eval q({ 0; });
    }' unless defined(&multi_timer_check);
    eval 'sub apicid_to_node {
        my($logical_apicid) = @_;
	    eval q({ 0; });
    }' unless defined(&apicid_to_node);
    eval 'sub cpu_present_to_apicid {
        my($mps_cpu) = @_;
	    eval q({  &if ($mps_cpu <  &get_physical_broadcast()) $mps_cpu;  &else  &BAD_APICID; });
    }' unless defined(&cpu_present_to_apicid);
    eval 'sub apicid_to_cpu_present {
        my($phys_apicid) = @_;
	    eval q({  &physid_mask_of_physid($phys_apicid); });
    }' unless defined(&apicid_to_cpu_present);
    eval 'sub mpc_apic_id {
        my($m,$translation_record) = @_;
	    eval q({  &printk(\\"Processor #%d %ld:%ld APIC version %d\\\\n\\",  ($m->{mpc_apicid}), ( ($m->{mpc_cpufeature}) &  &CPU_FAMILY_MASK) >> 8, ( ($m->{mpc_cpufeature}) &  &CPU_MODEL_MASK) >> 4,  ($m->{mpc_apicver})); ( ($m->{mpc_apicid})); });
    }' unless defined(&mpc_apic_id);
    eval 'sub setup_portio_remap {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&setup_portio_remap);
    eval 'sub check_phys_apicid_present {
        my($boot_cpu_physical_apicid) = @_;
	    eval q({  &physid_isset($boot_cpu_physical_apicid,  &phys_cpu_present_map); });
    }' unless defined(&check_phys_apicid_present);
    eval 'sub apic_id_registered {
        my($void) = @_;
	    eval q({  &physid_isset( &GET_APIC_ID( &apic_read( &APIC_ID)),  &phys_cpu_present_map); });
    }' unless defined(&apic_id_registered);
    eval 'sub cpu_mask_to_apicid {
        my($cpumask) = @_;
	    eval q({  &cpus_addr($cpumask)[0]; });
    }' unless defined(&cpu_mask_to_apicid);
    eval 'sub enable_apic_mode {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&enable_apic_mode);
    eval 'sub phys_pkg_id {
        my($cpuid_apic,$index_msb) = @_;
	    eval q({ $cpuid_apic >> $index_msb; });
    }' unless defined(&phys_pkg_id);
}
1;
