require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_MACH_APIC_H)) {
    eval 'sub __ASM_MACH_APIC_H () {1;}' unless defined(&__ASM_MACH_APIC_H);
    eval 'sub xapic_phys_to_log_apicid {
        my($cpu) = @_;
	    eval q(( $bios_cpu_apicid[$cpu]));
    }' unless defined(&xapic_phys_to_log_apicid);
    eval 'sub esr_disable () {(1);}' unless defined(&esr_disable);
    eval 'sub apic_id_registered {
        my($void) = @_;
	    eval q({ (1); });
    }' unless defined(&apic_id_registered);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub target_cpus {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&target_cpus);
    eval 'sub TARGET_CPUS () {( &target_cpus());}' unless defined(&TARGET_CPUS);
    if(defined (defined(&CONFIG_ES7000_CLUSTERED_APIC) ? &CONFIG_ES7000_CLUSTERED_APIC : 0)) {
	eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_CLUSTER);}' unless defined(&APIC_DFR_VALUE);
	eval 'sub INT_DELIVERY_MODE () {( &dest_LowestPrio);}' unless defined(&INT_DELIVERY_MODE);
	eval 'sub INT_DEST_MODE () {(1);}' unless defined(&INT_DEST_MODE);
	eval 'sub NO_BALANCE_IRQ () {(1);}' unless defined(&NO_BALANCE_IRQ);
	undef(&WAKE_SECONDARY_VIA_INIT) if defined(&WAKE_SECONDARY_VIA_INIT);
	eval 'sub WAKE_SECONDARY_VIA_MIP () {1;}' unless defined(&WAKE_SECONDARY_VIA_MIP);
    } else {
	eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_FLAT);}' unless defined(&APIC_DFR_VALUE);
	eval 'sub INT_DELIVERY_MODE () {( &dest_Fixed);}' unless defined(&INT_DELIVERY_MODE);
	eval 'sub INT_DEST_MODE () {(0);}' unless defined(&INT_DEST_MODE);
	eval 'sub NO_BALANCE_IRQ () {(0);}' unless defined(&NO_BALANCE_IRQ);
	undef(&APIC_DEST_LOGICAL) if defined(&APIC_DEST_LOGICAL);
	eval 'sub APIC_DEST_LOGICAL () {0x;}' unless defined(&APIC_DEST_LOGICAL);
	eval 'sub WAKE_SECONDARY_VIA_INIT () {1;}' unless defined(&WAKE_SECONDARY_VIA_INIT);
    }
    eval 'sub check_apicid_used {
        my($bitmap,$apicid) = @_;
	    eval q({ 0; } );
    }' unless defined(&check_apicid_used);
    eval 'sub check_apicid_present {
        my($bit) = @_;
	    eval q({  &physid_isset($bit,  &phys_cpu_present_map); });
    }' unless defined(&check_apicid_present);
    eval 'sub apicid_cluster {
        my($apicid) = @_;
	    eval q(($apicid & 0xf0));
    }' unless defined(&apicid_cluster);
    eval 'sub calculate_ldr {
        my($cpu) = @_;
	    eval q({ my $id;  $id =  &xapic_phys_to_log_apicid($cpu); ( &SET_APIC_LOGICAL_ID( $id)); });
    }' unless defined(&calculate_ldr);
    eval 'sub enable_apic_mode {
        my($void) = @_;
	    eval q({  &es7000_sw_apic(); ; });
    }' unless defined(&enable_apic_mode);
    eval 'sub clustered_apic_check {
        my($void) = @_;
	    eval q({ \'int\'  &apic =  $bios_cpu_apicid[ &smp_processor_id()];  &printk(\\"Enabling APIC mode:  %s.  Using %d I/O APICs, target cpus %lx\\\\n\\", ( $apic_version[ &apic] == 0x14) ? \\"Physical Cluster\\" : \\"Logical Cluster\\",  &nr_ioapics,  &cpus_addr( &TARGET_CPUS)[0]); });
    }' unless defined(&clustered_apic_check);
    eval 'sub multi_timer_check {
        my($apic,$irq) = @_;
	    eval q({ 0; });
    }' unless defined(&multi_timer_check);
    eval 'sub apicid_to_node {
        my($logical_apicid) = @_;
	    eval q({ 0; });
    }' unless defined(&apicid_to_node);
    eval 'sub cpu_present_to_apicid {
        my($mps_cpu) = @_;
	    eval q({  &if (!$mps_cpu)  &boot_cpu_physical_apicid;  &else  &if ($mps_cpu <  &NR_CPUS)  $bios_cpu_apicid[$mps_cpu];  &else  &BAD_APICID; });
    }' unless defined(&cpu_present_to_apicid);
    eval 'sub apicid_to_cpu_present {
        my($phys_apicid) = @_;
	    eval q({ \'int\'  &id = 0;  &physid_mask_t  &mask;  &mask =  &physid_mask_of_physid( &id); ++ &id;  &mask; });
    }' unless defined(&apicid_to_cpu_present);
    eval 'sub mpc_apic_id {
        my($m,$unused) = @_;
	    eval q({  &printk(\\"Processor #%d %ld:%ld APIC version %d\\\\n\\",  ($m->{mpc_apicid}), ( ($m->{mpc_cpufeature}) &  &CPU_FAMILY_MASK) >> 8, ( ($m->{mpc_cpufeature}) &  &CPU_MODEL_MASK) >> 4,  ($m->{mpc_apicver})); ( ($m->{mpc_apicid})); });
    }' unless defined(&mpc_apic_id);
    eval 'sub ioapic_phys_id_map {
        my($phys_map) = @_;
	    eval q({  &physids_promote(0xff); });
    }' unless defined(&ioapic_phys_id_map);
    eval 'sub setup_portio_remap {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&setup_portio_remap);
    eval 'sub check_phys_apicid_present {
        my($cpu_physical_apicid) = @_;
	    eval q({  &boot_cpu_physical_apicid =  &GET_APIC_ID( &apic_read( &APIC_ID)); (1); });
    }' unless defined(&check_phys_apicid_present);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub cpu_mask_to_apicid {
        my($cpumask) = @_;
	    eval q({ \'int\'  &num_bits_set; \'int\'  &cpus_found = 0; \'int\'  &cpu; \'int\'  &apicid;  &num_bits_set =  &cpus_weight($cpumask);  &if ( &num_bits_set ==  &NR_CPUS)  &cpu =  &first_cpu($cpumask);  &apicid =  &cpu_to_logical_apicid( &cpu);  &while ( &cpus_found <  &num_bits_set) {  &if ( &cpu_isset( &cpu, $cpumask)) { \'int\'  &new_apicid =  &cpu_to_logical_apicid( &cpu);  &if ( &apicid_cluster( &apicid) !=  &apicid_cluster( &new_apicid)){  &printk (\\"%s: Not a valid mask!\\\\n\\", &__FUNCTION__); }  &apicid =  &new_apicid;  &cpus_found++; }  &cpu++; }  &apicid; });
    }' unless defined(&cpu_mask_to_apicid);
    eval 'sub phys_pkg_id {
        my($cpuid_apic,$index_msb) = @_;
	    eval q({ $cpuid_apic >> $index_msb; });
    }' unless defined(&phys_pkg_id);
}
1;
