require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_MACH_APIC_H)) {
    eval 'sub __ASM_MACH_APIC_H () {1;}' unless defined(&__ASM_MACH_APIC_H);
    require 'asm/io.ph';
    require 'linux/mmzone.ph';
    require 'linux/nodemask.ph';
    eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_CLUSTER);}' unless defined(&APIC_DFR_VALUE);
    eval 'sub target_cpus {
        my($void) = @_;
	    eval q({  &CPU_MASK_ALL; });
    }' unless defined(&target_cpus);
    eval 'sub TARGET_CPUS () {( &target_cpus());}' unless defined(&TARGET_CPUS);
    eval 'sub NO_BALANCE_IRQ () {(1);}' unless defined(&NO_BALANCE_IRQ);
    eval 'sub esr_disable () {(1);}' unless defined(&esr_disable);
    eval 'sub INT_DELIVERY_MODE () { &dest_LowestPrio;}' unless defined(&INT_DELIVERY_MODE);
    eval 'sub INT_DEST_MODE () {0;}' unless defined(&INT_DEST_MODE);
    eval 'sub check_apicid_used {
        my($bitmap, $apicid) = @_;
	    eval q( &physid_isset($apicid, $bitmap));
    }' unless defined(&check_apicid_used);
    eval 'sub check_apicid_present {
        my($bit) = @_;
	    eval q( &physid_isset($bit,  &phys_cpu_present_map));
    }' unless defined(&check_apicid_present);
    eval 'sub apicid_cluster {
        my($apicid) = @_;
	    eval q(($apicid & 0xf0));
    }' unless defined(&apicid_cluster);
    eval 'sub apic_id_registered {
        my($void) = @_;
	    eval q({ 1; });
    }' unless defined(&apic_id_registered);
    eval 'sub ioapic_phys_id_map {
        my($phys_map) = @_;
	    eval q({  &physids_promote(0xf); });
    }' unless defined(&ioapic_phys_id_map);
    eval 'sub cpu_to_logical_apicid {
        my($cpu) = @_;
	    eval q({  &if ($cpu >=  &NR_CPUS)  &BAD_APICID;  $cpu_2_logical_apicid[$cpu]; });
    }' unless defined(&cpu_to_logical_apicid);
    eval 'sub generate_logical_apicid {
        my($quad,$phys_apicid) = @_;
	    eval q({ ($quad << 4) + ($phys_apicid ? $phys_apicid << 1: 1); });
    }' unless defined(&generate_logical_apicid);
    eval 'sub apicid_to_node {
        my($logical_apicid) = @_;
	    eval q({ $logical_apicid >> 4; });
    }' unless defined(&apicid_to_node);
    eval 'sub apicid_to_cpu_present {
        my($logical_apicid) = @_;
	    eval q({ \'int\'  &node =  &apicid_to_node($logical_apicid); \'int\'  &cpu =  &__ffs($logical_apicid & 0xf);  &physid_mask_of_physid( &cpu + 4* &node); });
    }' unless defined(&apicid_to_cpu_present);
    eval 'sub mpc_apic_id {
        my($m,$translation_record) = @_;
	    eval q({ \'int\'  &quad =  ($translation_record->{trans_quad}); \'int\'  &logical_apicid =  &generate_logical_apicid( &quad,  ($m->{mpc_apicid}));  &printk(\\"Processor #%d %ld:%ld APIC version %d (quad %d, apic %d)\\\\n\\",  ($m->{mpc_apicid}), ( ($m->{mpc_cpufeature}) &  &CPU_FAMILY_MASK) >> 8, ( ($m->{mpc_cpufeature}) &  &CPU_MODEL_MASK) >> 4,  ($m->{mpc_apicver}),  &quad,  &logical_apicid);  &logical_apicid; });
    }' unless defined(&mpc_apic_id);
    eval 'sub setup_portio_remap {
        my($void) = @_;
	    eval q({ \'int\'  &num_quads =  &num_online_nodes();  &if ( &num_quads <= 1) ;  &printk(\\"Remapping cross-quad port I/O for %d quads\\\\n\\",  &num_quads);  &xquad_portio =  &ioremap( &XQUAD_PORTIO_BASE,  &num_quads* &XQUAD_PORTIO_QUAD);  &printk(\\"xquad_portio vaddr 0x%08lx, len %08lx\\\\n\\",  &xquad_portio,  &num_quads* &XQUAD_PORTIO_QUAD); });
    }' unless defined(&setup_portio_remap);
    eval 'sub check_phys_apicid_present {
        my($boot_cpu_physical_apicid) = @_;
	    eval q({ (1); });
    }' unless defined(&check_phys_apicid_present);
    eval 'sub enable_apic_mode {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&enable_apic_mode);
}
1;
