require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_MACH_APIC_H)) {
    eval 'sub __ASM_MACH_APIC_H () {1;}' unless defined(&__ASM_MACH_APIC_H);
    require 'linux/config.ph';
    require 'asm/smp.ph';
    eval 'sub esr_disable () {(1);}' unless defined(&esr_disable);
    eval 'sub NO_BALANCE_IRQ () {(0);}' unless defined(&NO_BALANCE_IRQ);
    eval 'sub XAPIC_DEST_CPUS_SHIFT () {4;}' unless defined(&XAPIC_DEST_CPUS_SHIFT);
    eval 'sub XAPIC_DEST_CPUS_MASK () {((1 <<  &XAPIC_DEST_CPUS_SHIFT) - 1);}' unless defined(&XAPIC_DEST_CPUS_MASK);
    eval 'sub XAPIC_DEST_CLUSTER_MASK () {( &XAPIC_DEST_CPUS_MASK <<  &XAPIC_DEST_CPUS_SHIFT);}' unless defined(&XAPIC_DEST_CLUSTER_MASK);
    eval 'sub APIC_DFR_VALUE () {( &APIC_DFR_CLUSTER);}' unless defined(&APIC_DFR_VALUE);
    eval 'sub target_cpus {
        my($void) = @_;
	    eval q({  &cpumask_of_cpu(0); } );
    }' unless defined(&target_cpus);
    eval 'sub TARGET_CPUS () {( &target_cpus());}' unless defined(&TARGET_CPUS);
    eval 'sub INT_DELIVERY_MODE () {( &dest_LowestPrio);}' unless defined(&INT_DELIVERY_MODE);
    eval 'sub INT_DEST_MODE () {1;}' unless defined(&INT_DEST_MODE);
    eval 'sub check_apicid_used {
        my($bitmap,$apicid) = @_;
	    eval q({ 0; } );
    }' unless defined(&check_apicid_used);
    eval 'sub apicid_cluster {
        my($apicid) = @_;
	    eval q((($apicid) &  &XAPIC_DEST_CLUSTER_MASK));
    }' unless defined(&apicid_cluster);
    eval 'sub init_apic_ldr {
        my($void) = @_;
	    eval q({ my $val,  &id; \'int\'  &i,  &count;  &__u8  &lid;  &__u8  &my_id = ( &__u8) &hard_smp_processor_id();  &__u8  &my_cluster = ( &__u8) &apicid_cluster( &my_id);  &for ( &count = 0,  &i =  &NR_CPUS; -- &i >= 0; ) {  &lid =  $cpu_2_logical_apicid[ &i];  &if ( &lid !=  &BAD_APICID  &&  &apicid_cluster( &lid) ==  &my_cluster) ++ &count; }  &BUG_ON( &count >=  &XAPIC_DEST_CPUS_SHIFT);  &id =  &my_cluster | (1 <<  &count);  &apic_write_around( &APIC_DFR,  &APIC_DFR_VALUE);  $val =  &apic_read( &APIC_LDR) & ~ &APIC_LDR_MASK;  $val |=  &SET_APIC_LOGICAL_ID( &id);  &apic_write_around( &APIC_LDR,  $val); });
    }' unless defined(&init_apic_ldr);
    eval 'sub multi_timer_check {
        my($apic,$irq) = @_;
	    eval q({ 0; });
    }' unless defined(&multi_timer_check);
    eval 'sub apic_id_registered {
        my($void) = @_;
	    eval q({ 1; });
    }' unless defined(&apic_id_registered);
    eval 'sub clustered_apic_check {
        my($void) = @_;
	    eval q({  &printk(\\"Enabling APIC mode:  Summit.  Using %d I/O APICs\\\\n\\",  &nr_ioapics); });
    }' unless defined(&clustered_apic_check);
    eval 'sub apicid_to_node {
        my($logical_apicid) = @_;
	    eval q({ $logical_apicid >> 5; });
    }' unless defined(&apicid_to_node);
    eval 'sub cpu_present_to_apicid {
        my($mps_cpu) = @_;
	    eval q({  &if ($mps_cpu <  &NR_CPUS)  $bios_cpu_apicid[$mps_cpu];  &else  &BAD_APICID; });
    }' unless defined(&cpu_present_to_apicid);
    eval 'sub ioapic_phys_id_map {
        my($phys_id_map) = @_;
	    eval q({  &physids_promote(0xf); });
    }' unless defined(&ioapic_phys_id_map);
    eval 'sub apicid_to_cpu_present {
        my($apicid) = @_;
	    eval q({  &physid_mask_of_physid(0); });
    }' unless defined(&apicid_to_cpu_present);
    eval 'sub mpc_apic_id {
        my($m,$translation_record) = @_;
	    eval q({  &printk(\\"Processor #%d %ld:%ld APIC version %d\\\\n\\",  ($m->{mpc_apicid}), ( ($m->{mpc_cpufeature}) &  &CPU_FAMILY_MASK) >> 8, ( ($m->{mpc_cpufeature}) &  &CPU_MODEL_MASK) >> 4,  ($m->{mpc_apicver})); ( ($m->{mpc_apicid})); });
    }' unless defined(&mpc_apic_id);
    eval 'sub setup_portio_remap {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&setup_portio_remap);
    eval 'sub check_phys_apicid_present {
        my($boot_cpu_physical_apicid) = @_;
	    eval q({ 1; });
    }' unless defined(&check_phys_apicid_present);
    eval 'sub enable_apic_mode {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&enable_apic_mode);
    eval 'sub cpu_mask_to_apicid {
        my($cpumask) = @_;
	    eval q({ \'int\'  &num_bits_set; \'int\'  &cpus_found = 0; \'int\'  &cpu; \'int\'  &apicid;  &num_bits_set =  &cpus_weight;  &if ( &num_bits_set ==  &NR_CPUS) 0xff;  &cpu =  &first_cpu($cpumask);  &apicid =  &cpu_to_logical_apicid( &cpu);  &while ( &cpus_found <  &num_bits_set) {  &if ( &cpu_isset( &cpu, $cpumask)) { \'int\'  &new_apicid =  &cpu_to_logical_apicid( &cpu);  &if ( &apicid_cluster( &apicid) !=  &apicid_cluster( &new_apicid)){  &printk (\\"%s: Not a valid mask!\\\\n\\", &__FUNCTION__); 0xff; }  &apicid =  &apicid |  &new_apicid;  &cpus_found++; }  &cpu++; }  &apicid; });
    }' unless defined(&cpu_mask_to_apicid);
}
1;
